#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five28004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five28004xi = {
                1: '-1006x736y2507z',
                2: '-1027x1778y1902z',
                3: '-1064x696y2494z',
                4: '-1073x1608y2024z',
                5: '-1114x2413y878z',
                6: '-1120x651y2481z',
                7: '-1129x1738y1882z',
                8: '-1168x1566y2005z',
                9: '-1175x603y2468z',
                10: '-117x19y2797z',
                11: '-1227x551y2455z',
                12: '-1229x1692y1861z',
                13: '-1242x2359y852z',
                14: '-1261x1518y1985z',
                15: '-1277x495y2441z',
                16: '-131x847y2665z',
                17: '-1325x435y2427z',
                18: '-1328x1639y1840z',
                19: '-1352x1465y1965z',
                20: '-1369x2298y825z',
                21: '-1369x371y2413z',
                22: '-1410x304y2399z',
                23: '-1424x1581y1819z',
                24: '-1441x1406y1945z',
                25: '-1448x234y2384z',
                26: '-146x16y2796z',
                27: '-1482x160y2370z',
                28: '-1491x2230y798z',
                29: '-1512x84y2355z',
                30: '-1517x1517y1797z',
                31: '-1527x1341y1925z',
                32: '-1537x4y2339z',
                33: '-1608x1448y1776z',
                34: '-1610x1271y1905z',
                35: '-1611x2155y771z',
                36: '-1690x1196y1884z',
                37: '-1695x1373y1754z',
                38: '-1726x2074y744z',
                39: '-174x10y2794z',
                40: '-1766x1116y1863z',
                41: '-1779x1292y1732z',
                42: '-181x865y2656z',
                43: '-1838x1031y1842z',
                44: '-1838x1986y717z',
                45: '-1859x1207y1710z',
                46: '-1906x941y1821z',
                47: '-1934x1116y1688z',
                48: '-1944x1892y690z',
                49: '-1969x848y1800z',
                50: '-198x1885y2060z',
                51: '-2005x1021y1665z',
                52: '-2028x749y1778z',
                53: '-202x0y2792z',
                54: '-2045x1792y663z',
                55: '-2071x922y1643z',
                56: '-2081x648y1756z',
                57: '-2129x542y1734z',
                58: '-2131x818y1620z',
                59: '-2142x1687y636z',
                60: '-2172x433y1712z',
                61: '-2186x710y1597z',
                62: '-2208x321y1690z',
                63: '-2232x1576y609z',
                64: '-2236x599y1574z',
                65: '-2239x207y1668z',
                66: '-2280x484y1551z',
                67: '-2317x1460y581z',
                68: '-2317x367y1527z',
                69: '-233x880y2647z',
                70: '-2344x93y1704z',
                71: '-2348x246y1504z',
                72: '-2373x124y1480z',
                73: '-2391x0y1456z',
                74: '-2395x1339y554z',
                75: '-2466x1215y526z',
                76: '-2531x1086y499z',
                77: '-2589x954y471z',
                78: '-2640x818y444z',
                79: '-2683x680y416z',
                80: '-2719x539y388z',
                81: '-2748x397y361z',
                82: '-2768x253y333z',
                83: '-2781x108y305z',
                84: '-286x892y2638z',
                85: '-297x1740y2172z',
                86: '-299x1892y2041z',
                87: '-306x2582y1036z',
                88: '-33x11y2799z',
                89: '-342x901y2628z',
                90: '-393x1743y2154z',
                91: '-399x905y2619z',
                92: '-402x1893y2022z',
                93: '-443x2573y1010z',
                94: '-458x907y2609z',
                95: '-489x1741y2136z',
                96: '-506x1889y2003z',
                97: '-518x904y2598z',
                98: '-579x2556y984z',
                99: '-579x897y2588z',
                100: '-587x1733y2118z',
                101: '-60x16y2799z',
                102: '-610x1879y1983z',
                103: '-640x887y2577z',
                104: '-684x1720y2100z',
                105: '-6x2y2799z',
                106: '-702x872y2566z',
                107: '-715x1863y1963z',
                108: '-715x2531y958z',
                109: '-763x853y2554z',
                110: '-782x1701y2081z',
                111: '-819x1841y1943z',
                112: '-825x830y2543z',
                113: '-849x2499y931z',
                114: '-84x827y2673z',
                115: '-880x1676y2062z',
                116: '-886x803y2531z',
                117: '-88x19y2798z',
                118: '-923x1813y1923z',
                119: '-946x771y2519z',
                120: '-977x1645y2043z',
                121: '-982x2460y905z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800five4xi" usage = "target function for charge28004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2800five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2800FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five28004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five28004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2800FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800five4xi.py                             
# -------------------------------------------------------------------------------------------------                